This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 1119004 - Review Request: python-characteristic - Say 'yes' to types but 'no' to typing!
Review Request: python-characteristic - Say 'yes' to types but 'no' to typing!
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Robert Mayr
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1119063
  Show dependency treegraph
 
Reported: 2014-07-12 23:02 EDT by Tom Prince
Modified: 2015-07-21 08:56 EDT (History)
2 users (show)

See Also:
Fixed In Version: python-characteristic-14.3.0-1.fc21
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-01-18 20:34:52 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
robyduck: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Tom Prince 2014-07-12 23:02:12 EDT
Spec URL: http://data.hybridcluster.net/fedora-scratch/python-characteristic.spec
SRPM URL: http://data.hybridcluster.net/fedora-scratch/python-characteristic-0.1.0-2.fc20.src.rpm
Fedora Account System Username: tomprince
Description: 
characteristic is an Python package with class decorators that ease the chores of implementing the most common attribute-related object protocols.

You just specify the attributes to work with and ``characteristic`` gives you:

- a nice human-readable ``__repr__``,
- a complete set of comparison methods,
- and a kwargs-based initializer (that cooperates with your existing one)

*without* writing dull boilerplate code again and again.
Comment 1 Christopher Meng 2014-07-12 23:11:16 EDT
1. Summary:        Say 'yes' to types but 'no' to typing!

What's this???

2. Changelog section need some love, take a shot at these examples:

http://fedoraproject.org/wiki/Packaging:Guidelines#Changelogs

3. BuildRequires:  python-devel

https://fedoraproject.org/wiki/Packaging:Python#BuildRequires

4. %{python3_sitelib}/test_%{srcname}.py
%{python3_sitelib}/__pycache__/%{srcname}.*.py[co]
%{python3_sitelib}/__pycache__/test_%{srcname}.*.py[co]

A bit complicated, if you want to be lazy, just use this:

%{python3_sitelib}/*

5. %{python3_sitelib}/%{srcname}-%{version}-py?.?.egg-info

If you want to be more specific, use this:

5. %{python3_sitelib}/%{srcname}-%{version}-py%{python3_version}.egg-info

Same applies to the python2.

6. 79 chars per line in the %description.
Comment 2 Tom Prince 2014-07-13 11:57:28 EDT
> 1. Summary:        Say 'yes' to types but 'no' to typing!
> What's this???

Upstreams description of the package.

Spec URL: http://data.hybridcluster.net/fedora-scratch/python-characteristic.spec
SRPM URL:http://data.hybridcluster.net/fedora-scratch/python-characteristic-0.1.0-3.fc20.src.rpm
Koji URL: http://koji.fedoraproject.org/koji/taskinfo?taskID=7134561
Comment 3 Michael Schwendt 2014-08-04 16:45:40 EDT
> A bit complicated, if you want to be lazy, just use this:
> 
> %{python3_sitelib}/*

Not good, because it would include the __pycache__ directory that belongs into a different package.

The ".*.py[co]" matches are fine but "*%{srcname}*" would have been okay as a lazy solution:

  %{python3_sitelib}/*%{srcname}*
  %{python3_sitelib}/__pycache__/*%{srcname}*


> Requires:       python

Unneeded, because there is a better automatic dependency already:

  $ rpm -qpR python-characteristic-0.1.0-3.fc21.noarch.rpm |grep ^py
  python
  python(abi) = 2.7


> Requires:       python3

Same here:

  $ rpm -qpR python3-characteristic-0.1.0-3.fc21.noarch.rpm |grep ^py
  python(abi) = 3.4
  python3


> Koji URL: http://koji.fedoraproject.org/koji/taskinfo?taskID=7134561

Instead of a plain koji build, running "fedora-review -b 1119004" and looking into its various output files is highly recommended for new packagers.
Comment 5 Robert Mayr 2014-12-18 06:31:10 EST
I don't know if you're still working on this, if not please tell me, I'd be happy to take it.
I can only do an unofficial review of the package, it should be more or less on the right way for now, clean it up a bit and update your files. (maybe use a better link).

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 5 files have unknown license. Detailed output of
     licensecheck in /home/robyduck/Pubblici/1119004-python-
     characteristic/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[?]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[?]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[?]: Package does not generate any conflict.
[?]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[?]: Requires correct, justified where necessary.
[!]: Spec file is legible and written in American English.
See attachment, also I saw some tabs.

[-]: Package contains systemd file(s) if in need.
[?]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[?]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[?]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-characteristic
[?]: Package functions as described.
[!]: Latest version is packaged.
Last version seems to be 14.2.0.

[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python-characteristic-14.1.0-1.fc20.noarch.rpm
          python3-characteristic-14.1.0-1.fc20.noarch.rpm
          python-characteristic-14.1.0-1.fc20.src.rpm
python-characteristic.noarch: W: spelling-error %description -l en_US repr -> rep, reps, rear
python-characteristic.noarch: W: spelling-error %description -l en_US kwargs -> awkward
python-characteristic.noarch: W: spelling-error %description -l en_US initializer -> initialize, initializes, initialized
python3-characteristic.noarch: W: spelling-error %description -l en_US repr -> rep, reps, rear
python3-characteristic.noarch: W: spelling-error %description -l en_US kwargs -> awkward
python3-characteristic.noarch: W: spelling-error %description -l en_US initializer -> initialize, initializes, initialized
python-characteristic.src: W: spelling-error %description -l en_US repr -> rep, reps, rear
python-characteristic.src: W: spelling-error %description -l en_US kwargs -> awkward
python-characteristic.src: W: spelling-error %description -l en_US initializer -> initialize, initializes, initialized
3 packages and 0 specfiles checked; 0 errors, 9 warnings.



Rpmlint (installed packages)
----------------------------
# rpmlint python-characteristic python3-characteristic
python-characteristic.noarch: W: spelling-error %description -l en_US repr -> rep, reps, rear
python-characteristic.noarch: W: spelling-error %description -l en_US kwargs -> awkward
python-characteristic.noarch: W: spelling-error %description -l en_US initializer -> initialize, initializes, initialized
python3-characteristic.noarch: W: spelling-error %description -l en_US repr -> rep, reps, rear
python3-characteristic.noarch: W: spelling-error %description -l en_US kwargs -> awkward
python3-characteristic.noarch: W: spelling-error %description -l en_US initializer -> initialize, initializes, initialized
2 packages and 0 specfiles checked; 0 errors, 6 warnings.
# echo 'rpmlint-done:'


Requires
--------
python-characteristic (rpmlib, GLIBC filtered):
    python(abi)

python3-characteristic (rpmlib, GLIBC filtered):
    python(abi)


Provides
--------
python-characteristic:
    python-characteristic

python3-characteristic:
    python3-characteristic
Comment 7 Robert Mayr 2014-12-28 16:47:53 EST
Ok, can you also update the changelog with the correct date?
Comment 9 Robert Mayr 2015-01-02 07:31:27 EST
Looks good now, please remember to rebuild also the SRPM.
Thanks.
Comment 10 Tom Prince 2015-01-02 10:19:10 EST
New Package SCM Request
=======================
Package Name: python-characteristic
Short Description: Python library that eases the chores of implementing attributes
Upstream URL: https://github.com/hynek/characteristic/
Owners: tomprince
Branches: f21 epel7
InitialCC:
Comment 11 Jon Ciesla 2015-01-02 11:13:54 EST
Git done (by process-git-requests).
Comment 12 Fedora Update System 2015-01-02 18:22:16 EST
python-characteristic-14.3.0-1.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/python-characteristic-14.3.0-1.fc21
Comment 13 Fedora Update System 2015-01-05 02:33:25 EST
python-characteristic-14.3.0-1.fc21 has been pushed to the Fedora 21 testing repository.
Comment 14 Fedora Update System 2015-01-18 20:34:52 EST
python-characteristic-14.3.0-1.fc21 has been pushed to the Fedora 21 stable repository.

Note You need to log in before you can comment on or make changes to this bug.